\documentclass{report}
  
\usepackage{common/uruwi}

\title{x801tr03 Requirements}
\author{uruwi}

\begin{document}

\pagecolor{Rhodamine!15}

\maketitle

\trsummary

\section{Introduction}

This report delves into the extended details of requirements outlined in tr02. At the same time, tr03 assumes that one has read tr02.

\newcommand{\rationale}[1]{\textit{Rationale:} #1}

\section{Objective}

We intend to create a free (as in speech) multiplayer RPG with Wizard101-like combat mechanics; anyone can read its source code or modify it.

Ideally, it should be straightforward to run a small server for the game, while being able to scale to thousands of concurrent players at the same time. The server program should be relatively efficient with resources.

\chapter{Requirements}

\section{Functional}

\subsection{Servers and accounts}

\begin{enumerate}
  \item As a user:
  \begin{enumerate}
    \item I would like to be able to log into a server with an account with its username and password.
    \item I would like any assets required to connect to a server to be downloaded or updated automatically upon joining.
    \item I would like to have a player character associated with an account.
    \item If I do not already have a player character, I would like to be prompted to create one.
  \end{enumerate}
  \item As an administrator of a server:
  \begin{enumerate}
    \item I would like to be able to ban a user from my server temporarily or permanently.
    \item I would like to be able to revoke such bans.
    \item I would like to be able to choose between setting display names to usernames or requiring the display name to be selected from a fixed list of components (à la w101).
  \end{enumerate}
\end{enumerate}

\subsection{Movement and interaction}

\begin{enumerate}
  \item As a user:
  \begin{enumerate}
    \item I would like to be able walk around the world using the arrow keys.
    \item I would like to see the locations of other players near me.
    \item When I collide with a portal, I would like to be directed to the place it leads to.
    \item I would like to be able to press a button to teleport to the main area of a world.
    \item I would like to be able to press a button to mark my location, at the cost of mana.
    \item I would like to be able to teleport to the location I last marked.
    \item I would like to have the location of my player and my marked location, if any, to be saved.
    \item When I enter an instanced area, I and other players entering with me should be alone in a new instance.
    \item I would like to be able to send public chat messages.
    \item I would like to hear any chat messages sent in my area.
    \item I would like to be able to send private messages.
    \item I would like to be able to send and receive friend requests.
    \item I would like to view another player's profile.
    \item I would like to be able to interact with NPCs.
    \item I would like to be able to walk near a health or mana wisp to restore some of my health or mana.
    \item I would like to regenerate health passively in non-combat areas.
  \end{enumerate}
  \item As an administrator of a server:
  \begin{enumerate}
    \item I would like to be able to mute a user from my server temporarily or permanently.
    \item I would like to be able to revoke such mutes.
    \item I would like to configure a chat filter.
  \end{enumerate}
  \item As an asset developer:
  \begin{enumerate}
    \item I would like to be able to create and edit areas.
    \item I would like to be able to place portals in areas.
    \item I would like to be able to place NPCs in areas.
    \item I would like to be able to specify whether an area is an instance and specify the maximum player count.
    \item I would like to specify the appearance of NPCs.
    \item I would like to be able to specify a piece of music to be used for a certain area, separately in and out of combat.
  \end{enumerate}
\end{enumerate}

\subsection{Inventory and equipment}

\begin{enumerate}
  \item As a user:
  \begin{enumerate}
    \item I would like to be able to open the inventory menu.
    \item I would like to be able to scroll between different inventory sections.
    \item I would like to see the number of items I have in a given section and its limit.
    \item I would like to see the name and properties of each item.
    \item I would like to be able to equip and unequip items in the equipment section.
    \item I would like to have my statistics affected by equipment as shown in their descriptions.
    \item I would like to have level requirements on equipment enforced.
    \item I would like to see my current combat statistics.
    \item I would like to be able to see the amount of gold I have.
    \item I would like to have my inventory and gold saved.
  \end{enumerate}
  \item As an asset developer:
  \begin{enumerate}
    \item I would like to be able to add arbitrary inventory sections.
    \item I would like to be able to specify the maximum item count, stackability and extended attributes of items this section.
    \item I would like to be able to specify subsections of a section.
    \item I would like to be able to control the display properties of a section.
    \item I would like to be able to add and edit items and change their properties.
    \item I would like to be able to set an item's appearance.
  \end{enumerate}
\end{enumerate}

\subsection{Combat}

\begin{enumerate}
  \item As a user:
  \begin{enumerate}
    \item I would like to enter a battle by moving near an enemy.
    \item I would like to use my current deck in battles.
    \item I would like to see the cards in my hand during planning.
    \item I would like to see the health and the number of pips of all entities in battle.
    \item I would like to see the hanging effects of all entities in the battle.
    \item I would like to see the current global.
    \item I would like to see the spells that my allies are planning to play.
    \item I would like to be able to left-click a card to plan to play it.
    \item I would like to be able to right-click a card to discard it.
    \item I would like to be able to click the pass button to pass.
    \item I would like to be able to undo a pending move.
    \item I would like to be able to flee at the cost of all of my mana.
    \item When all entities have taken their turn, I would like to see the effects of each spell played.
    \item When a spell is cast, I would like to see its animation and splats for the spell's effects.
    \item I would like to be able to deal as much damage or heal as much health as the system allows, with no arbitrary limits.
    \item In player-versus-enemy combat, I would like to have my mana consumed according to the rank of a spell.
    \item I would like to gain experience upon winning a player-versus-enemy battle.
    \item I would like to be able to join a practice PvP match by selecting an available match or creating one.
    \item I would like to be able to join a ranked PvP match by allowing the matchmaking system to find another player with a similar level and skill as mine.
    \item I would like to have my PvP rank adjusted at the end of a ranked PvP match.
    \item I would like to avoid being matched against the same player repeatedly in ranked matches.
    \item I would like to have other mechanics to prevent boosting.
    \item I would like to see a leaderboard of the players with the highest PvP ranks.
    \item I would like to see a leaderboard of the hits with the highest amount of damage dealt.
    \item I would like to have my PvP rank and win statistics saved.
    \item I would like to be able to press a button to gain a level if I have enough experience. \rationale{Player level is not automatically increased because it might sometimes be profitable to stay at a lower level, and some players might want to stay at a low level as a self-imposed challenge.}
  \end{enumerate}
  \item As an administrator of a server:
  \begin{enumerate}
    \item I would like to be able to start a new PvP age and reset PvP ranks.
  \end{enumerate}
  \item As an asset developer:
  \begin{enumerate}
    \item I would like to be able to create and edit spells.
    \begin{enumerate}
      \item I would like to be able to set the rank of a spell, either to a nonnegative integer or `X'.
      \item I would like to be able to set the accuracy and school of a spell.
      \item I would like to be able to set the effects of a spell.
      \item I would like to be able to specify complex computations to calculate the effects of a spell.
      \item I would like for the spell's description to be derived automatically from its effects.
      \item I would like to be able to set the image used on a spell's card.
      \item I would like to be able to set a spell's animation.
    \end{enumerate}
    \item I would like to be able to create and edit enemies.
    \begin{enumerate}
      \item I would like to be able to set an enemy's health and school.
      \item I would like to be able to set an enemy's resistances and vulnerabilities.
      \item I would like to be able to set the list of spells that an enemy will use.
      \item I would like to be able to specify any cheats the enemy has.
      \item I would like to be able to set an enemy's appearance.
      \item I would like to be able to specify a piece of music to be used for a certain enemy.
    \end{enumerate}
    \item I would like to be able to create and edit schools.
    \begin{enumerate}
      \item I would like to be able to set a school's logo and casting animation.
      \item I would like to be able to specify which schools have mastery of which.
    \end{enumerate}
  \end{enumerate}
\end{enumerate}

\subsection{Quests}

\begin{enumerate}
  \item As a user:
  \begin{enumerate}
    \item I would like to be able to interact with NPCs.
    \item I would like to be able to receive quests from NPCs.
    \item I would like to have a visual indicator for NPCs that have a quest available.
    \item I would like to have a visual indicator for NPCs that I can interact with to progress with a quest.
    \item I would like to be notified whenever I make progress on a quest.
    \item I would like to be able to view my quests.
    \item I would like to be able to select a quest as active.
    \item I would like to have a guide to where I need to go next for my active quest.
    \item I would like to gain rewards such as experience on completing a quest.
    \item I would like to have my quest progress saved.
  \end{enumerate}
  \item As an asset developer:
  \begin{enumerate}
    \item I would like to be able to create and edit quests.
    \item I would like to be able to specify the prerequisites of a quest.
    \item I would like to be able to add objectives to quests (see tr02).
    \item I would like to be able to specify dialogue to be played when an objective is completed.
    \item I would like to be able to specify ordering dependencies between objectives.
    \item I would like to disable the quest guide for certain objectives.
    \item I would like to be able to specify rewards for completing a quest.
    \item I would like to be able to make NPCs move, appear or disappear in response to quest progress.
  \end{enumerate}
\end{enumerate}

\subsection{Trading}

\begin{enumerate}
  \item As a user:
  \begin{enumerate}
    \item I would like to be able to trade items with another player.
    \item I would like to be able to view a shop's inventory.
    \item I would like to be able to buy items from a shop.
    \item I would like to be able to start a shop in a vacant slot, possibly for some gold.
    \item I would like to be able to add or remove items in my shop.
    \item I would like to be able to set prices for items in my shop.
    \item When my shop closes, I would like to have its items be moved to storage for retrieval.
    \item I would like to have shop inventories saved.
    \item I would like to avoid having items lost or duplicated as a result of a trade.
  \end{enumerate}
  \item As an asset developer:
  \begin{enumerate}
    \item I would like to be able to specify whether items from certain sections are tradeable.
    \item I would like to be able to specify whether individual items are tradeable.
    \item I would like to be able to configure shop slots and their corresponding capacities.
    \item For shop slots managed by NPCs, I would like to be able to configure restocking behaviour.
    \item For shop slots managed by players, I would like to be able to configure the price for renting a slot and the amount of time it is rented for.
  \end{enumerate}
\end{enumerate}

\subsection{Crafting}

\begin{enumerate}
  \item As a user:
  \begin{enumerate}
    \item I would like to be able to obtain crafting recipes.
    \item I would like to be able to find reagents.
    \item I would like to be able to use recipes to craft items.
    \item I would like to be able to advance crafting levels.
    \item I would like to be able to interact with an NPC to convert (`scrap') items into reagents.
  \end{enumerate}
  \item As an asset developer:
  \begin{enumerate}
    \item I would like to be able to add new reagents.
    \item I would like to be able to add crafting recipes.
  \end{enumerate}
\end{enumerate}

\subsection{Housing}

\begin{enumerate}
  \item As a user:
  \begin{enumerate}
    \item I would like to be able to buy a plot.
    \item I would like to be able to teleport to my plot.
    \item I would like to be able to place and remove housing items on my plot.
    \item I would like to be able to expand my plot.
    \item I would like to have my plots saved.
  \end{enumerate}
  \item As an asset developer:
  \begin{enumerate}
    \item I would like to be able to add new housing items.
  \end{enumerate}
\end{enumerate}

\subsection{Pets}

\begin{enumerate}
  \item As a user:
  \begin{enumerate}
    \item I would like to be able to acquire pets.
    \item I would like to be able to play minigames to train my pet.
    \item I would like to be able to feed snacks to my pet.
    \item I would like to have my pet level up and manifest talents.
    \item I would like to be able to breed pets.
  \end{enumerate}
  \item As an asset developer:
  \begin{enumerate}
    \item I would like to be able to add new pets.
  \end{enumerate}
\end{enumerate}

\section{Non-functional}

\begin{enumerate}
  \item Both the client and server should be free of concurrency or security problems.
  \item Any action performed by the player should be reflected to the same player without any noticeable delay.
  \item Any action performed by one player should be reflected to other players within 2 seconds on a good network connection.
  \item It should be straightforward to run a small server for the game.
  \item At the same time, it should be possible to run a server with thousands of concurrent players.
  \item The client and ideally the server should run on both Windows and GNU/Linux at the very least.
  \item It should be possible to upgrade the assets to a new game version without migrating the database.
\end{enumerate}

\chapter{Design decisions}

\section{2-D or 3-D graphics?}

What kind of graphics will we use?

\begin{enumerate}
  \item two-dimensional, top down
  \item three-dimensional, first- or third-person
\end{enumerate}

3-D is more immersive but assets (i.e.~entity and terrain models) will be much harder to create. As a result, a top-down style is more ideal.

Prior art: w101 has 3-D graphics, but producing new content requires many artists and adds to its cost.

\section{Navigation?}

How will the game world be divided?

\begin{enumerate}
  \item mostly one big map
  \item split into many discrete zones
\end{enumerate}

Splitting the map into many zones loses some immersion, but such a model is easier to parallelise. Even with the former approach, we would need code to handle multiple zones because of instancing.

Prior art: w101 uses the latter approach.

\section{Entity limit in teams?}

How should the entity limit per team be specified?

\begin{enumerate}
  \item fixed constant (e.g.~4 or 6)
  \item configurable by asset developer
  \item configurable per battle
\end{enumerate}

Setting it to a fixed constant is the simplest approach of the three. While increasing the limit might unlock new possibilities, it is probably best to avoid setting it too high. For instance, if each team could have eight players, then it would be possible to use degenerate strategies such as having a team of seven healers and one attacker. At the same time, we don't want to force everyone to be limited to our decisions. We could instead use the second option and have the list of entities on each side be represented by a dynamically allocated array, and this can easily be adapted to the third option if needed.

Prior art: w101 has it fixed to 4.

\section{How to acquire cards?}

How should cards be acquired? (one or more of the following)

\begin{enumerate}
  \item train spells to put as many copies as the deck allows
  \item as items that are good for one copy in the deck but are not consumed on use
  \item as items that are placed in a separate section of the deck and are consumed on use
\end{enumerate}

(2) better reflects how cards work in real life, but raises a few problems:

\begin{itemize}
  \item some useful off-school spells cost 0 or 1 pips -- including spells that would not be trainable under (1) (e.g.~w101 Balanceblade) -- and those that cost many training points to train off-school (e.g.~w101 Feint)
  \item should placing a card in one deck preclude using it in another?
  \item might increase grind factor
\end{itemize}

Prior art: w101 does (1) and (3).

\section{Gear stats?}

How should stats on equipment be assigned?

\begin{enumerate}
  \item each item type has fixed stats
  \item randomly assign stats with constraints
\end{enumerate}

The latter option provides more depth and might entail less work creating items explicitly, but it also raises some problems:

\begin{itemize}
  \item how to assign a name to such an item?
  \item how to describe how stats are assigned in assets?
  \item complicates saving items to the database
  \item might increase grind factor
\end{itemize}

Prior art: w101 mostly does (1), except:

\begin{itemize}
  \item some equipment can have sockets for jewels, which add more stat bonuses
  \item pets dropped from enemies have a fixed set of talents (according to their species), but each pet will manifest a subset of talents at random as they are trained; breeding pets also results in a pet with a mix of talents from both parents
\end{itemize}

\end{document}
